"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#Workstation
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Interface-Graphics'
!

Workstation comment:'
COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

$Header: /cvs/stx/stx/libview/Attic/Workstat.st,v 1.14 1995-06-27 02:20:47 claus Exp $
'!

Smalltalk at:#Display      put:nil!

!Workstation class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libview/Attic/Workstat.st,v 1.14 1995-06-27 02:20:47 claus Exp $
"
!

documentation
"
    this class is only here, to get an instance of XWorkstation
    named Display - this cannot be done in XWorkstation since Display
    is defined in X.h/Xlib.h -- sigh
"
! !

!Workstation class methodsFor:'initialization'!

initialize
    |workstationType|

    "
     initialize the default display - this must be done only once
    "
    Display isNil ifTrue:[
	"
	 figure out, which display class to use
	 (if multiple have been bound into the system)
	"

	"
	 if there is a GL-XWorkstation, use it
	"
	GLXWorkstation notNil ifTrue:[
	    workstationType := GLXWorkstation.
	] ifFalse:[
	    workstationType := XWorkstation
	].

	workstationType notNil ifTrue:[
	    "
	     make sure its initialized ...
	    "
	    workstationType initialize.
	].

	"
	 preparation for NeXTStep interfacing;
	 (but if X is linked in, this will be our default Display
	  this will change later)
	"
	NeXTWorkstation notNil ifTrue:[
	    NeXTWorkstation initialize.

	    workstationType isNil ifTrue:[
		workstationType := NeXTWorkstation
	    ]
	].

	"
	 preparation for OS2 interfacing;
	 (but if X is linked in, this will be our default Display
	  this will change later ...)
	"
	OS2Workstation notNil ifTrue:[
	    OS2Workstation initialize.

	    workstationType isNil ifTrue:[
		workstationType := OS2Workstation
	    ]
	].

	"
	 preparation for Win32 interfacing;
	 (but if X is linked in, this will be our default Display)
	  this will change later ...)
	"
	Win32Workstation notNil ifTrue:[
	    Win32Workstation initialize.

	    workstationType isNil ifTrue:[
		workstationType := Win32Workstation
	    ]
	].

	workstationType notNil ifTrue:[
	    Display isNil ifTrue:[
		Display := workstationType basicNew initializeFor:nil.
	    ]
	].

	"
	 if we found any display, make it the default, and
	 initialize the global RootView.
	 RootView is a historic leftover and does not really make
	 sense in multi-display operation. Try not to use it, it may
	 vanish over time (use aDevice rootView)
	"
	Display notNil ifTrue:[
	    DeviceWorkstation default:Display.
	    DisplayRootView initialize.
	    Screen := Display class.
	]
    ]
!

reinitialize
    "reinitialize after a snapin."

    "
     this code will eventually handle the case where we come up
     on another type of workstation. For now, images save while running
     on X will not work properlly on some other device
    "
    Display notNil ifTrue:[
	Display reinitialize.
    ]
! !
